#include "window.h"
#include "complexmath.h"// PI
#include <cmath>	// cos(), in w2k3ddk/inc/crt

template<class T> bool BlackmanWindow<T>::resize(size_t N) {
 if (N==size()) return true;
 if (!commit_undefined(N)) return false;
 T a = T(0.16),
   a0 = T(1-a)/2,
   a1 = T(0.5),
   a2 = T(a/2);
 for (size_t i=0; i!=N; i++) _begin[i]=a0 - a1*cos(T(PI2
 )*i/(N-1)) + a2*cos(T(PI_2)*i/(N-1));
 return true;
}

template class BlackmanWindow<float>;


template<class T> bool SoftWindow<T>::rebuild(int N, int a, int e, int l) {
 if (N==int(size())) return true;
 if (N<0 || a<0 || e<0 || l<0 || l>N>>1 || a>=e) return false;
 int l2=l>>1, lr=l-l2;
 if (a<l2) a=l2;
 if (e>N-lr) e=N-lr;
 if (a+l>e) return false;
 if (!commit_undefined(N)) return false;
 if (range.a==a && range.e==e) return true;
 range.a=a; range.e=e;
 int b[4]={a-l2,a+lr,e-l2,e+lr};	// Verknpfungspunkte 0,Flanke+,1,Flanke-,0
 for (int i=0; i!=N; i++) {
  T v=0;
  if (i<b[0]) (void)0;
  else if (i<b[1]) v=T(0.5)*(1+sin((i-a)*T(PI)/l));
  else if (i<b[2]) v=1;
  else if (i<b[3]) v=T(0.5)*(1-sin((i-e)*T(PI)/l));
  _begin[i]=v;
 }
 return true;
}

template<class T> T SoftWindow<T>::damp() const{
 return T(range.size())/T(size());
}

template class SoftWindow<float>;
