#pragma once
#include "../util/vector.h"
#include "../util/gdix.h"

template<class T>class BlackmanWindow:public vector<T> {
public:
 bool resize(size_t);
};

// Dieses Fenster generiert cosx-Flanken in der Mitte von <a> und <e>.
// Die Flankenlnge betrgt <l>.
// Liefert false wenn l > sz/2 oder a>=e oder irgendetwas negativ.
// <a> zu dicht am Anfang wird l/2 weggerckt, ebenso <e> vom Ende.
// Ergibt sich dann a+l>e kommt nochmal false.
// Ansonsten ist's ein Rechteckfenster, bei l<2 exakt rechteckig.
// Tut nichts wenn sich die Gre nicht ndert.
template<class T>class SoftWindow:public vector<T> {
public:
 IntRange<int>range;	// Tatschlicher Fensterbereich (Mitte-Mitte)
 T damp() const;	// Signaldmpfungsma = range.size()/size(), 0..1
 bool rebuild(int sz,int a,int e,int l);
};
